org.apache.jmeter.functions

## Class EvalVarFunction

- java.lang.Object
- - org.apache.jmeter.functions.AbstractFunction
  - - org.apache.jmeter.functions.EvalVarFunction

- All Implemented Interfaces:
    Function

      public class EvalVarFunction
      extends AbstractFunction

  Function to evaluate a string which may contain variable or function references. Parameter: string to be evaluated Returns: the evaluated value
  Since:
    2.3.1

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `EvalVarFunction()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `execute(SampleResult previousResult, Sampler currentSampler)` N.B. execute() should be synchronized if function is operating with non-thread-safe objects (e.g. operates with files).
    `java.util.List<java.lang.String>` | `getArgumentDesc()` Return a list of strings briefly describing each parameter your function takes.
    `java.lang.String` | `getReferenceKey()` Return the name of your function.
    `void` | `setParameters(java.util.Collection<CompoundVariable> parameters)` Note: This is always called even if no parameters are provided (versions of JMeter after 2.3.1)

    - ### Methods inherited from class org.apache.jmeter.functions.AbstractFunction

      `addVariableValue, checkMinParameterCount, checkParameterCount, checkParameterCount, execute, getVariables`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### EvalVarFunction

          public EvalVarFunction()

  - ### Method Detail

    - #### execute

          public java.lang.String execute(SampleResult previousResult,
                                          Sampler currentSampler)
                                   throws InvalidVariableException

      N.B. execute() should be synchronized if function is operating with non-thread-safe objects (e.g. operates with files).

      JMeter ensures setParameters() happens-before execute(): setParameters is executed in main thread, and worker threads are started after that.
      Specified by:
        `execute` in interface `Function`
      Specified by:
        `execute` in class `AbstractFunction`
      Parameters:
        `previousResult` - The previous `SampleResult`
        `currentSampler` - The current `Sampler`
      Returns:
        The replacement value, which was generated by the function
      Throws:
        `InvalidVariableException` - - when the variables for the function call can't be evaluated
      See Also:
        `Function.execute(SampleResult, Sampler)`

    - #### setParameters

          public void setParameters(java.util.Collection<CompoundVariable> parameters)
                             throws InvalidVariableException

      Note: This is always called even if no parameters are provided (versions of JMeter after 2.3.1)
      Specified by:
        `setParameters` in interface `Function`
      Specified by:
        `setParameters` in class `AbstractFunction`
      Parameters:
        `parameters` - The parameters for the function call
      Throws:
        `InvalidVariableException` - - when the variables for the function call can't be evaluated
      See Also:
        `Function.setParameters(Collection)`

    - #### getReferenceKey

          public java.lang.String getReferenceKey()

      Return the name of your function. Convention is to prepend "__" to the name (ie "__regexFunction")
      Specified by:
        `getReferenceKey` in interface `Function`
      Specified by:
        `getReferenceKey` in class `AbstractFunction`
      Returns:
        The name of the function
      See Also:
        `Function.getReferenceKey()`

    - #### getArgumentDesc

          public java.util.List<java.lang.String> getArgumentDesc()

      Return a list of strings briefly describing each parameter your function takes. Please use JMeterUtils.getResString(resource_name) to grab a resource string. Otherwise, your help text will be difficult to internationalize. This list is not optional. If you don't wish to write help, you must at least return a List containing the correct number of blank strings, one for each argument.
      Returns:
        List with brief descriptions for each parameter the function takes

Copyright © 1998-2019 Apache Software Foundation. All Rights Reserved.